package ru.ulstu.user.model;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import ru.ulstu.core.model.BaseEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

@Entity
@Table(name = "users_conference")
public class UserConference extends BaseEntity {

    @NotNull
    @Column(name = "participation", nullable = false)
    private String participation;

    @NotNull
    @Column(name = "deposit", nullable = false)
    private String deposit;

    @ManyToOne(optional = false)
    @JoinColumn(name = "users_id")
    private User user;

    public UserConference() {
    }

    public UserConference(String participation, String deposit, User user) {
        this.participation = participation;
        this.deposit = deposit;
        this.user = user;
    }

    @JsonCreator
    public UserConference(@JsonProperty("id") Integer id,
                          @JsonProperty("participation") String participation,
                          @JsonProperty("deposit") String deposit,
                          @JsonProperty("user") User user) {
        this.setId(id);
        this.participation = participation;
        this.deposit = deposit;
        this.user = user;
    }


    public String getParticipation() {
        return participation;
    }

    public void setParticipation(String participation) {
        this.participation = participation;
    }

    public String getDeposit() {
        return deposit;
    }

    public void setDeposit(String deposit) {
        this.deposit = deposit;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

}
